(* $Id: printer.ml,v 1.1 2007/01/17 23:36:00 fclement Exp $ *)

type 'a t = Buffer.t -> 'a -> unit;;
type 'a printer = 'a t;;

let set_max_iprint, get_max_iprint = My_options.aref 25;;

let print_same_elements iprint count a print_elem ob prev =
  if !iprint = get_max_iprint () then begin
    Printf.bprintf ob "...";
    incr iprint end else begin
  if !iprint < get_max_iprint () then begin
    if a = !prev then incr count else begin
    if !count > 1 then Printf.bprintf ob "(%dx) " !count;
    Printf.bprintf ob "%a; " print_elem !prev;
    count := 1;
    incr iprint;
    prev := a end end end;;

let print_same_last_elements iprint count print_elem ob prev =
  if !iprint = get_max_iprint () then Printf.bprintf ob "..." else begin
  if !iprint < get_max_iprint () then begin
    if !count > 1 then Printf.bprintf ob "(%dx) " !count;
    Printf.bprintf ob "%a" print_elem !prev end end;;
